2021-06-04 belangeo <belangeo@gmail.com>

    * Git tag: 1.0.4.

2021-05-08 belangeo <belangeo@gmail.com>

    * TableMorph checks table sizes before interpolating to prevent segmentation fault.

2021-05-08 belangeo <belangeo@gmail.com>

    * Scale's exp argument now supports float or PyoObject.

2021-05-08 belangeo <belangeo@gmail.com>

    * Added documentation for IFFTMatrix object.

2021-05-08 belangeo <belangeo@gmail.com>

    * Added support for item assigment in PyoObjectBase.

2021-01-24 belangeo <belangeo@gmail.com>

    * Fixed FreqShift backward shifting (issue #193).

2021-01-21 belangeo <belangeo@gmail.com>

    * Removed deprecated files.

2021-01-21 belangeo <belangeo@gmail.com>

    * Added Visaul Studio Code integration for Windows, MacOS and Linux.

2021-01-17 belangeo <belangeo@gmail.com>

    * Fixed memory allocation in expr's initexpr function (issue #190).

2020-12-20 belangeo <belangeo@gmail.com>

    * On 64-bit architecture, use long instead of int as PyoObjectTable size.

2020-12-13 belangeo <belangeo@gmail.com>

    * PyoTableObject get(), put() and copyData() methods can read backward with negative indices.

2020-12-12 belangeo <belangeo@gmail.com>

    * Fixed crash when DataTable or NewTable size != len(init).

2020-12-10 belangeo <belangeo@gmail.com>

    * Fixed PadSynthTable crash on Windows.

2020-11-30 belangeo <belangeo@gmail.com>

    * VarPort now updates its increment when the time attribute changes.

2020-11-27 belangeo <belangeo@gmail.com>

    * Added a level argument to PyoMatrixObject.normalize() method.

2020-11-26 belangeo <belangeo@gmail.com>

    * Fixed segmentation fault in PyoMatrixObject.read() method.

2020-11-25 belangeo <belangeo@gmail.com>

    * Added a div method to PyoTableObject.

2020-11-25 belangeo <belangeo@gmail.com>

    * Added a shape argument to PyoTableObject.fadein() and PyoTableObject.fadeout() methods.

2020-11-23 belangeo <belangeo@gmail.com>

    * Added a level argument to PyoTableObject.normalize() method.

2020-11-12 belangeo <belangeo@gmail.com>

    * Added PyoObjectBase.getStopDelay() method (mainly for unit testing).

2020-08-28 belangeo <belangeo@gmail.com>

    * Git tag: 1.0.3.

2020-08-28 belangeo <belangeo@gmail.com>

    * Fixed missing lib dependency links on MacOS.

2020-08-17 belangeo <belangeo@gmail.com>

    * Git tag: 1.0.2.

2020-08-02 belangeo <belangeo@gmail.com>

    * Added new object: MML, Music Macro Language evaluator.

2020-06-27 belangeo <belangeo@gmail.com>

    * Fixed segfault in reducePoints function.

2020-06-27 belangeo <belangeo@gmail.com>

    * Fixed Linseg when time difference between two points is less than 1 sample.

2020-02-10 belangeo <belangeo@gmail.com>

    * Added new object: TriangleTable.

2020-01-20 belangeo <belangeo@gmail.com>

    * Added new object: IFFTMatrix, Inverse Fast Fourier Transform with a PyoMatrixObject as input.

2020-01-07 belangeo <belangeo@gmail.com>

    * PVBuffer's length attribute can now be changed dynamically.

2019-11-27 belangeo <belangeo@gmail.com>

    * Git tag: 1.0.1.

2019-11-24 belangeo <belangeo@gmail.com>

    * Added beatToDur(beat, bpm) function.

2019-11-15 belangeo <belangeo@gmail.com>

    * Added examples about how to use OSC protocol with pyo.

2019-11-12 belangeo <belangeo@gmail.com>

    * Added utilities examples.

2019-11-11 belangeo <belangeo@gmail.com>

    * Added events examples.

2019-11-05 belangeo <belangeo@gmail.com>

    * Added the first version of the Events framework.

2019-10-22 belangeo <belangeo@gmail.com>

    * Fixed tkinter font size on MacOS (fixed issue #163).

2019-10-14 belangeo <belangeo@gmail.com>

    * Added setChannelNames(names) method to Spectrum and Scope objects.

2019-10-10 belangeo <belangeo@gmail.com>

    * Fixed segfault when CallAfter's callback results in deleting itself
      (its stop method was then called on a deallocated object).

2019-09-30 belangeo <belangeo@gmail.com>

    * Expr API: constants (pi, twopi, e, sr) can be used without braces.

2019-09-29 belangeo <belangeo@gmail.com>

    * Expr API: Expr now can generate multiple output signals.

2019-09-29 belangeo <belangeo@gmail.com>

    * Expr API: Expr now can handle multiple input sources.

2019-09-28 belangeo <belangeo@gmail.com>

    * Expr API: let statment can now store a complex number.

2019-09-19 belangeo <belangeo@gmail.com>

    * Added a DC blocker inside the feedback loop of Harmonizer object.

2019-09-11 belangeo <belangeo@gmail.com>

    * Added new object: Binaural, 3D stereo spatialization.

2019-09-11 belangeo <belangeo@gmail.com>

    * Added a clear() method to Mixer object to delete all inputs at once.

2019-09-09 belangeo <belangeo@gmail.com>

    * Fixed setting value of ControlSlider from national keyboard layout.

2019-09-03 belangeo <belangeo@gmail.com>

    * Audio server falls back to playback-only mode if jack server has no input ports.

2019-07-11 belangeo <belangeo@gmail.com>

    * Git tag: 1.0.0.

2019-06-12 belangeo <belangeo@gmail.com>

    * EPyo: Fix search ctrl behaviour in the documentation window.

2019-06-05 belangeo <belangeo@gmail.com>

    * Better handling of bad code when reading file in enbedded pyo.

2019-06-02 belangeo <belangeo@gmail.com>

    * Added a clear() method to Linseg and Expseg objects.

2019-05-14 belangeo <belangeo@gmail.com>

    * Added computer keyboard bindings when the Notein's keyboard widget has the focus.

2019-02-22 belangeo <belangeo@gmail.com>

    * Fader and Adsr now send a trigger at the end of the envelope.

2019-02-22 belangeo <belangeo@gmail.com>

    * CallAfter's time and arg arguments can be changed dynamically.

2019-01-24 belangeo <belangeo@gmail.com>

    * Jack audio backend does not ignore duplex value anymore.

2019-01-24 belangeo <belangeo@gmail.com>

    * Added two arithmetic objects: Div and Sub.

2019-01-22 belangeo <belangeo@gmail.com>

    * Changed PyoObjectBase's method preventAutoStart() for all AutoStart(switch).
    
2019-01-11 belangeo <belangeo@gmail.com>

    * Added setStopDelay method to PyoObjectBase class.

2019-01-09 belangeo <belangeo@gmail.com>

    * Added examples about multirate processing/synthesis.

2019-01-08 belangeo <belangeo@gmail.com>

    * Fixed all variant of audio arithmetic.

2018-12-28 belangeo <belangeo@gmail.com>

    * Added a new object: SVF2, a 2-pole state variable filter with many filter types.

2018-12-26 belangeo <belangeo@gmail.com>

    * Added a getPyoExamples function and changed example function to be able to
      execute one of the example.

2018-12-26 belangeo <belangeo@gmail.com>

    * Fixed SIGSEGV when multiplying a number and a base object.

2018-12-14 belangeo <belangeo@gmail.com>

    * Compiling for python 64-bit on Windows now work.

2018-12-14 belangeo <belangeo@gmail.com>

    * Fixed break-point-function tables malloc() corruption.

2018-12-14 belangeo <belangeo@gmail.com>

    * Changed the structure of the source code and the installed dependencies.

2018-12-11 belangeo <belangeo@gmail.com>

    * Added PyoObjectBase.preventAutoStart() method to stop propagation when
      autoStartChildren is activated in the Server.

2018-12-11 belangeo <belangeo@gmail.com>

    * Fixed bug in OscDataSend.addAddress().

2018-12-11 belangeo <belangeo@gmail.com>

    * Added autoStartChildren feature. For detail, see doc for Server.setAutoStartChildren,
      PyoObjectBase.useWaitTimeOnStop, PyoObjectBase.addLinkedObject and PyoObject.stop.

2018-11-22 belangeo <belangeo@gmail.com>

    * Added keyboard method to the Notein object (opens a virtual midi keyboard).

2018-11-20 belangeo <belangeo@gmail.com>

    * Added a new object: PyoGuiKeyboard, a virtual MIDI keyboard.

2018-11-06 belangeo <belangeo@gmail.com>

    * Embedded: Added a BPM variable in the embedded interpreter and a function in 
      PyoClass to change it according to the BPm of a DAW, for instance.

2018-11-02 belangeo <belangeo@gmail.com>

    * Embedded: Remove the wx import before importing pyo to prevent a crash on MacOS.

2018-11-02 belangeo <belangeo@gmail.com>

    * Fixed crash on first load when embedding pyo in a juce plugin.

2018-10-30 belangeo <belangeo@gmail.com>

    * Added complex numbers (and complex one-pole/one-zero filters) to the Expr API.

2018-10-30 belangeo <belangeo@gmail.com>

    * Added sr (returns the current sampling rate) constant to the Expr API.

2018-10-23 belangeo <belangeo@gmail.com>

    * Added one-sample delay function and sr constant to the Expr api.

2018-10-23 belangeo <belangeo@gmail.com>

    * Fixed phase of sawtooth and ramp waveform in the LFO object.

2018-10-23 belangeo <belangeo@gmail.com>

    * Epyo: Added multiple views (splitted windows) functionnality.

2018-10-22 belangeo <belangeo@gmail.com>

    * Epyo Doc: Bug fixes and added zoomin/zoomout function.

2018-10-21 belangeo <belangeo@gmail.com>

    * Epyo: Added a 'Reload Current File' menu command.

2018-10-21 belangeo <belangeo@gmail.com>

    * Epyo: Added auto complete for cpp file (from corresponding header file).

2018-10-05 belangeo <belangeo@gmail.com>

    * Merged E-Pyo and PyoDoc in a single file (now in pyolib/editor/EPyo.py).

2018-10-05 belangeo <belangeo@gmail.com>

    * Modified setup.py to be pip compliant.

2018-10-04 belangeo <belangeo@gmail.com>

    * E-Pyo: Fixed crash when trying to read a faulty preferences file.

2018-09-06 belangeo <belangeo@gmail.com>

    * Added PYO_SERVER_MIDI and PYO_SERVER_WINHOST environment variables to set
      default values for the audio server.

2018-09-04 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.9.1.

2018-09-04 belangeo <belangeo@gmail.com>

    * On Windows, use 'directsound' as the default audio host (much more 
      reliable than 'wasapi').

2018-05-30 belangeo <belangeo@gmail.com>

    * Fixed phase shifting between the frequency bands of FourBand and MultiBand.

2018-04-24 belangeo <belangeo@gmail.com>

    * Added a new object: MultiBand, frequency splitter using Linkwitz-Riley 
      crossover filters.

2018-04-17 belangeo <belangeo@gmail.com>

    * Fixed Compress output level when input's rms is above unity.

2018-03-04 belangeo <belangeo@gmail.com>

    * Added the ability to remove a project from the project tree.

2018-03-02 belangeo <belangeo@gmail.com>

    * Added getPrecision() function. Removed print statement when importing pyo.
      User should use getVersion() and getPrecision() functions if needed.

2018-03-02 belangeo <belangeo@gmail.com>

    * Fixed crash when asking for more input or output channels than available.

2018-03-01 belangeo <belangeo@gmail.com>

    * Fixed Server window's Interpreter field scrolling history on MacOS.

2018-02-16 belangeo <belangeo@gmail.com>

    * Added release-notes for version 0.9.0.

2018-02-16 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.9.0.

2018-02-16 belangeo <belangeo@gmail.com>

    * Added a Server.makenote(pitch, velocity, duration, channel=0) method.

2018-02-15 belangeo <belangeo@gmail.com>

    * Added a new object: MidiLinseg, a midi-triggered breakpoints envelope.

2018-02-13 belangeo <belangeo@gmail.com>

    * Added a new object: RMS, which return the rms value of an audio signal.

2018-02-13 belangeo <belangeo@gmail.com>

    * Added a new object: Expand, which expand the dynamic range of an audio signal.

2018-02-10 belangeo <belangeo@gmail.com>

    * HRTF impulse responses are now interpolated in the spectral domain to 
      avoid phase cancellation that occur in the time domain.

2018-02-03 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.9.

2018-02-03 belangeo <belangeo@gmail.com>

    * Added new object: HRTF, Head-Related Transfert Function 3D spatialization.

2018-02-01 belangeo <belangeo@gmail.com>

    * Fixed crash when trying to draw a ControlSlider with width or height of 0.

2018-01-31 belangeo <belangeo@gmail.com>

    * Fixed window shape in the Harmonizer object (use an halfsine instead 
      of an hanning).

2018-01-25 belangeo <belangeo@gmail.com>

    * Fixed segfault at exit when a Server object is created but never 
      booted (fixed issue #117).

2018-01-14 belangeo <belangeo@gmail.com>

    * Fixed pa_get_devices_infos() function on Windows.

2018-01-12 belangeo <belangeo@gmail.com>

    * Allow the "mode" argument of Resample object to be changed dynamically.

2017-12-16 belangeo <belangeo@gmail.com>

    * Fixed erroneous condition in listscramble function.

2017-11-26 belangeo <belangeo@gmail.com>

    * Speed-up computation for various objects.

2017-11-07 belangeo <belangeo@gmail.com>

    * Changed the stereo panning law for cosine/sine within Pan object.

2017-11-07 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.8.

2017-11-07 belangeo <belangeo@gmail.com>

    * E-Pyo: fixed tempfile encoding on windows.

2017-11-07 belangeo <belangeo@gmail.com>

    * Fixed path encoding on windows for python 3.6.

2017-11-06 belangeo <belangeo@gmail.com>

    * Properly incref and decref server references inside pyo objects.

2017-11-06 belangeo <belangeo@gmail.com>

    * Added missing objects in server's garbage collecting process.

2017-11-06 belangeo <belangeo@gmail.com>

    * Fixed audio and midi backends memory allocation.

2017-11-05 belangeo <belangeo@gmail.com>

    * Don't try to deactivate jack if it is stopped externally (ex. from
      qjackctl). Fixed issue #109.

2017-11-03 belangeo <belangeo@gmail.com>

    * Added a callback attribute to PVAnal. The function receives magnitudes
      and true frequencies for every analysis frame.

2017-11-02 belangeo <belangeo@gmail.com>

    * Fixed PyoArgumentTypeError when ctrl() is called for an object with
      dataOnly parameter and tk is used instead of wxpython.

2017-11-02 belangeo <belangeo@gmail.com>

    * Granulator now compensates for the difference between the loaded sound's
      sampling rate and pyo's sampling rate, if any.

2017-11-01 belangeo <belangeo@gmail.com>

    * E-Pyo: Fixed crash when preferences contains unicode characters.

2017-10-31 belangeo <belangeo@gmail.com>

    * E-Pyo: template, snippets and other features now defaults to python3.

2017-10-15 belangeo <belangeo@gmail.com>

    * Added a new init argument (wintitle) to Scope and Spectrum objects to
      allow the user to set the title name of their window. Also added a
      method to show/hide the channel labels in their window.

2017-10-09 belangeo <belangeo@gmail.com>

    * Added Jack midi support to the Server.

2017-10-09 belangeo <belangeo@gmail.com>

    * Added missing static declaration to functions in pyomodule.

2017-10-07 belangeo <belangeo@gmail.com>

    * Removed internal import of the random module. Scripts importing
      both pyo and random modules segfault on garbagge collection at exit.

2017-09-15 belangeo <belangeo@gmail.com>

    * Added missing binding to stop method in MidiListener.

2017-09-06 belangeo <belangeo@gmail.com>

    * Added windows audio inspector script.

2017-08-31 belangeo <belangeo@gmail.com>

    * Fixed compiling with debug symbols on MacOS.

2017-08-28 belangeo <belangeo@gmail.com>

    * Fixed VoiceManager dealloc function.

2017-08-28 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.7.

2017-08-28 belangeo <belangeo@gmail.com>

    * Update MacOS and Windows build routine to compile for python 2.7,
      3.5 and 3.6.

2017-08-xx belangeo <belangeo@gmail.com>

    * Fixed encoding of path for various objects.

2017-08-25 belangeo <belangeo@gmail.com>

    * Fixed clean-up of VoiceManager object.

2017-08-25 belangeo <belangeo@gmail.com>

    * Fixed ending point of TableRec's time stream (now keep the last 
      value instead of switching back to 0).

2017-08-23 belangeo <belangeo@gmail.com>

    * Fixed windows 10 dependencies.

2017-08-07 belangeo <belangeo@gmail.com>

    * OscDataSend now can send more than one message per buffer size.

2017-06-28 belangeo <belangeo@gmail.com>

    * Fixed Expr unicode handling.

2017-06-27 belangeo <belangeo@gmail.com>

    * Wrap jack api detection inside a try-except statement in case
      jack2-dbus is used instead of jackd.

2017-06-05 belangeo <belangeo@gmail.com>

    * Added getInterpolated method to PyoMatrixObject class.

2017-06-05 belangeo <belangeo@gmail.com>

    * The server now allow up to 16 channel rms outputs for GUI drawing.

2017-05-18 belangeo <belangeo@gmail.com>

	* Disable Microsoft Midi devices by default. Added
	  Server.allowMicrosoftMidiDevices() method to enable them.

2017-05-16 belangeo <belangeo@gmail.com>

    * Converted remaining print statements to function calls.

2017-04-20 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.6.

2017-04-20 belangeo <belangeo@gmail.com>

    * Added a Copy menu item in PyoObject.ctrl() and DataTable.graph() windows.

2017-04-20 belangeo <belangeo@gmail.com>

    * Added setRandomType(dist, x) method to SfMarkerShuffler object.

2017-04-20 belangeo <belangeo@gmail.com>

    * Fixed TableRec, TrigTableRec and Looper time stream not started on play.

2017-04-18 belangeo <belangeo@gmail.com>

    * Fixed libraries dynamic links in MacOS installer scripts.

2017-04-13 belangeo <belangeo@gmail.com>

    * Fixed segfault in Resample_dealloc function.

2017-04-10 belangeo <belangeo@gmail.com>

    * Wrapped non-blocking offline processing between PyGILState_Ensure and
    PyGILState_Release calls.

2017-04-10 belangeo <belangeo@gmail.com>

    * Updated liblo from 0.26 to 0.28 on Windows. This fixes a bug with socket
    not properly closed.

2017-04-09 belangeo <belangeo@gmail.com>

    * Fixed segfault when updating ControlSlider value from the audio thread.

2017-04-07 belangeo <belangeo@gmail.com>

    * Fixed CallAfter segfault when deleted inside its own callback.

2017-04-06 belangeo <belangeo@gmail.com>

    * Fixed TableRead which continues to play when freq is negative and loop is off.

2017-04-06 belangeo <belangeo@gmail.com>

    * Added "speed" argument to Seq object. Useful to create continuous time
      deceleration or acceleration.

2017-03-31 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.5.

2017-03-31 belangeo <belangeo@gmail.com>

    * Added two examples in 07-effects, 01-flanger.py and 02-schroeder-reverb.py.

2017-03-31 belangeo <belangeo@gmail.com>

    * Removed Server.setInOutDefaultDeviceFromHost(host) method.
      Added a new winhost argument to the Server's initialization.
      Added pa_get_default_devices_from_host(host) function.

2017-03-27 belangeo <belangeo@gmail.com>

    * Check the jack api version before compiling to ensure existing
    functions are used (jack_port_set_name/jack_port_rename).

2017-03-26 belangeo <belangeo@gmail.com>

    * Added setInOutDefaultDeviceFromHost(host) to the Server object.

2017-03-24 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.4.

2017-03-23 belangeo <belangeo@gmail.com>

    * Added `id` and `object` attributes to wxgui's object events.

2017-03-22 belangeo <belangeo@gmail.com>

    * Added setJackInputPortNames and setJackOutputPortNames methods to the
      Server object. This allow the user to rename jack input/output ports.

2017-03-21 belangeo <belangeo@gmail.com>

    * Updated portaudio interface to make it much more secure.

2017-03-20 belangeo <belangeo@gmail.com>

    * Added setIsJackTransportSlave method to Server object (it allows to
      start/stop the Server from jack transport).

2017-03-17 belangeo <belangeo@gmail.com>

    * Fixed GIL conflicts with portaudio, portmidi and jack library calls.

2017-03-11 belangeo <belangeo@gmail.com>

    * Added a setKeepLast method to TableRead object (will hold last value).

2017-03-10 belangeo <belangeo@gmail.com>

    * Added a setMode method to Selector object to switch between
      equal power mode and linear fade.

2017-03-06 belangeo <belangeo@gmail.com>

    * Fixed SfMarkerLooper and SfMarkerShuffler markers not accurate
      when soundfile sampling rate is not the same as the server's
      sampling rate.

2017-03-04 belangeo <belangeo@gmail.com>

    * Added a "title" argument to Server.gui() method.

2017-03-03 belangeo <belangeo@gmail.com>

    * MidiDispatcher can send sysex message with sendx() method.

2017-03-03 belangeo <belangeo@gmail.com>

    * Midi input refactoring. Events are now spreaded over the buffer size
	  according to the event's timestamp.

2017-02-19 belangeo <belangeo@gmail.com>

    * Added examples about multicore audio programming with pyo.

2017-02-14 belangeo <belangeo@gmail.com>

    * Fixed segfault in MidiListener callback function with python3.
    * Fixed string versus unicode in MidiDispatcher's getDeviceInfos method.

2017-02-13 belangeo <belangeo@gmail.com>

    * Final revision for version 0.8.3.

2017-02-13 belangeo <belangeo@gmail.com>

    * Added new object: MidiDispatcher, self-contained midi dispatcher thread.
      Updated MidiListener.

2017-02-12 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.3.

2017-02-12 belangeo <belangeo@gmail.com>

    * Prevents the creation of a SharedTable object on Windows (not implemented yet).

2017-02-12 belangeo <belangeo@gmail.com>

    * Fader and Adsr now start a new envelope from the current amplitude value
      if the previous ramp has not finished yet.

2017-02-12 belangeo <belangeo@gmail.com>

    * Added new object: TableScan, Reads the content of a table in loop,
      without interpolation.

2017-02-11 belangeo <belangeo@gmail.com>

    * Added setGlobalDur, setGlobalDel, getGlobalDur and getGlobalDel methods
      to the Server object. These methods allow the user to manage starttime
      and duration of audio objects globally.

2017-02-09 belangeo <belangeo@gmail.com>

    * Added shape argument to PVAmpMod and PVFreqMod objects. 
      It allows to change the modulation oscillator's waveform.

2017-02-08 belangeo <belangeo@gmail.com>

    * Added onlyonce argument to Beat object.

2017-02-08 belangeo <belangeo@gmail.com>

    * Seq now accepts floating-point values as time units.

2017-02-07 belangeo <belangeo@gmail.com>

    * Added maxwindow argument to TableWrite. This is the maximum number of samples
      over which the object is allowed to interpolate. Useful to avoid interpolation
      over the entire table when using a circular writing pointer.

2017-02-05 belangeo <belangeo@gmail.com>

    * Added new object: TableFill, continuously fills a table with incoming samples.

2017-02-04 belangeo <belangeo@gmail.com>

    * Added onlyonce argument to Seq object.

2017-01-30 belangeo <belangeo@gmail.com>

    * Added new object: Particle2, An even more full control granular synthesis generator.

2017-01-08 belangeo <belangeo@gmail.com>

    * Added new object: SharedTable, an inter-process shared memory table.

2017-01-07 belangeo <belangeo@gmail.com>

    * Jack ports activation and auto-connection now happen in the boot process.

2016-12-17 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.2.

2016-12-17 belangeo <belangeo@gmail.com>

    * Fixed bug in Bendin value. Fixed midi input events handling. Set 
      interpolation to off by default for midi continuous controllers.

2016-12-17 belangeo <belangeo@gmail.com>

    * E-Pyo: Fixed a bug in the documentation window.

2016-12-17 belangeo <belangeo@gmail.com>

    * TrigFunc and Pattern now accept tuple as arg argument (fixed issue #90).

2016-12-15 belangeo <belangeo@gmail.com>

    * Fixed portaudio suggested latency for realtime performance.

2016-12-08 belangeo <belangeo@gmail.com>

    * Upgraded version number to 0.8.1.

2016-12-08 belangeo <belangeo@gmail.com>

    * Iter now accepts PyoObjects in its list of values.

2016-12-08 belangeo <belangeo@gmail.com>

    * Iter now sends a thrigger when it reaches the last value.

2016-11-25 belangeo <belangeo@gmail.com>

    * SigTo ramp time now can be controlled at audio rate (issue #87).

2016-11-23 belangeo <belangeo@gmail.com>

    * Added __iter__(), __next__() and next() (python 2 compatibility) methods 
      to PyoBaseObject.

2016-11-22 belangeo <belangeo@gmail.com>

    * Added reset method to various objects (AllpassWG, Chorus, Freeverb, 
      Harmonizer, STRev, WGVerb, Waveguide).

2016-11-16 belangeo <belangeo@gmail.com>

    * TableWrite now takes into account the feedback argument of NewTable 
      object and interpolates to fill in gaps if position moves faster than 
      the sampling rate.

2016-11-07 belangeo <belangeo@gmail.com>

    * Added missing methods to Notein object and ctrl() method in midi.py. 

2016-11-07 belangeo <belangeo@gmail.com>

    * Added a `callback` argument to PyoObject.set() method. 

2016-11-06 Aron Granberg <http://arongranberg.com>

    * Python 3 migration. Still need to port pyo's GUI written with WxPython
      to WxPython Phoenix (the port of WxPython Classic to python 3). Some
      widgets are broken.  

2016-11-02 belangeo <belangeo@gmail.com>

    * Fixed jack ports auto-connection algorithm. 

2016-10-28 belangeo <belangeo@gmail.com>

    * Added an 'inverse' argument to PVGate object. When set to True, the 
      damping factor is applied to bins with an amplitude above the threshold.

2016-10-26 belangeo <belangeo@gmail.com>

    * Added a time stream, which gives the current normalized position, to Looper object.
    
    * Added loopnow() method to Looper object.
    
    * Added appendFadeTime() and fadeInSeconds() methods to Looper object.

2016-10-24 belangeo <belangeo@gmail.com>

    * Added a new file, called `How to improve performance of your pyo
      programs`, to the documentation.

2016-10-21 belangeo <belangeo@gmail.com>

    * Added Server.getCurrentTime() and Server.getCurrentAmp() methods.

2016-10-04 belangeo <belangeo@gmail.com>

    * Added new object: LogiMap, random generator based on the logistic map.

    * Added Server.setCallback method to allow the user to define a custom
      process function. This function will be called once per buffer size, 
      just before the computation of the audio object tree. 
      
    * Added PyoTableObject.getBuffer() method. The PyoTableObject now support 
      the buffer protocol (see PEP 3118), which allow a table to share its 
      data memory with any object that support the buffer protocol 
      (ex. numpy ndarray). 

2016-09-29 belangeo <belangeo@gmail.com>

    * Added sysexout() method to the Server object.

2016-09-08 belangeo <belangeo@gmail.com>

    * Added new examples, 05-envelopes and 06-filters.

2016-08-09 belangeo <belangeo@gmail.com>

    * Replaced all printf statements with PySys_WriteStdout. This allow to
      redirect message from pyo to a string or a file, instead of the stdout.

2016-06-01 belangeo <belangeo@gmail.com>

    * Added WDMKS in the portaudio build routine.

2016-05-13 belangeo <belangeo@gmail.com>

    * Fixed wrong definition of withOsc() and withCoreaudio().
    * Real final revision for version 0.8.0.
    - SHA: 

2016-05-12 belangeo <belangeo@gmail.com>

    * Final revision for version 0.8.0.
    - SHA: e833e404e20e9531b901ee8924b66f711f3c5e8f

2016-05-10 belangeo <belangeo@gmail.com>

    * Added new functions: withPortaudio, withPortmidi, withCoreaudio, withJack, withOSC.

2016-05-10 belangeo <belangeo@gmail.com>

    * Added a bela framework (BeagleBone Black) with instructions in the embedded folder.

2016-05-10 belangeo <belangeo@gmail.com>

    * Added a new compilation flag, --minimal, to build without portaudio, portmidi and liblo.

2016-05-10 belangeo <belangeo@gmail.com>

    * Added new examples on the online documentation.

2016-05-06 belangeo <belangeo@gmail.com>

    * Made portaudio, portmidi and liblo optional dependencies.

2016-04-29 belangeo <belangeo@gmail.com>

    * Added a quality factor everywhere a FLAC or OGG sound file can be saved on disk.

2016-04-03 belangeo <belangeo@gmail.com>

    * Disto uses now a simple but more efficient waveshaper formula. This algorithm 
	  is faster and does not produce large amplitude variation like the atan2 function.

2016-04-03 belangeo <belangeo@gmail.com>

    * Added new object: Exp, calculates the value of e to the power of x.

2016-04-02 belangeo <belangeo@gmail.com>

    * Revision, clean-up and optimization of various filters in the library.
    (Biquad, Biquadx, Port, Tone, Atone, Allpass, Allpass2, Phaser, BandSplit MoogLP).

2016-03-31 belangeo <belangeo@gmail.com>

    * Fixed bug when a LFO object receives a negative frequency.

2016-03-28 belangeo <belangeo@gmail.com>

    *  Added new object: FastSine, two fast sin approximations (faster than linear table lookup).

2016-03-27 belangeo <belangeo@gmail.com>

    *  Added new function : getPyoKeywords, returns the list of pyo keywords (classes and functions).

2016-03-26 belangeo <belangeo@gmail.com>

    *  Added an argument arg to the Pattern object.

2016-03-25 belangeo <belangeo@gmail.com>

    *  Fixed unwanted offset in type 7 (sinmod) of LFO object.

2016-03-23 belangeo <belangeo@gmail.com>

    *  Added setExp() method to Fader, Adsr, MidiAdsr and MidiDelAdsr, allowing

2016-03-18 belangeo <belangeo@gmail.com>

    *  Fixed Counter.reset() method.

2016-03-18 belangeo <belangeo@gmail.com>

    *  A CallAfter object can now be triggered many times.

2016-03-18 belangeo <belangeo@gmail.com>

    *  Added new object: MoogLP, 24dB/oct resonant lowpass filter.

2016-03-16 belangeo <belangeo@gmail.com>

    *  Added new object: ChenLee, another chaotic attractor based on the Chen-Lee system.

2016-03-16 belangeo <belangeo@gmail.com>

    *  Added new object: PadSynthTable, a beautiful algorithm from Nasca Octavian Paul.

2016-03-13 belangeo <belangeo@gmail.com>

    *  Added rotate and copyData methods to the PyoTableObject.

2016-03-12 belangeo <belangeo@gmail.com>

    *  Fixed TableWrite writing pointer in the table. Added a mode attribute
    to select between normalized (0->1) or raw (samples) position.

2016-03-01 belangeo <belangeo@gmail.com>

    * Final revision for version 0.7.9.
    - SHA: 7ddbeacd14cd78ce4930c845a82745bb58f4a26c

2016-03-01 belangeo <belangeo@gmail.com>

    *  Upgraded version number to 0.7.9.

2016-03-01 belangeo <belangeo@gmail.com>

    *  Pyo now uses its own PRNG to avoid conflicts with other libs or 
    modules that use rand()/srand() in the same process. This fixed the 
    Server's global seed behaviour.

2016-02-29 belangeo <belangeo@gmail.com>

    * Fixed a bug, introduced by unicode addresses handler, in Open Sound 
    Control objects.

2016-02-29 belangeo <belangeo@gmail.com>

    * Exposed internal GUI widgets in the official API. New objects are
    PyoGuiControlSlider, PyoGuiVuMeter, PyoGuiGrapher, PyoGuiMultiSlider,
    PyoGuiSpectrum, PyoGuiScope and PyoGuiSndView.

2016-02-17 belangeo <belangeo@gmail.com>

    * E-Pyo: Added a warning before quitting the application.

2016-02-12 belangeo <belangeo@gmail.com>

    * Fixed a bug in Notein voice assignation.

2016-02-12 belangeo <belangeo@gmail.com>

    * Added readyToDetect() method to AttackDetector object.

2016-01-29 belangeo <belangeo@gmail.com>

    * Fixed segfault in Server dealloc function.

2016-01-08 belangeo <belangeo@gmail.com>

    * Final revision for version 0.7.8.
    - SHA: e71cb0b5254da456bea129113da3d258a5b75dea

2016-01-07 belangeo <belangeo@gmail.com>

    * Added new object: Expr, sample-based prefix expression evaluator.

2015-12-04 belangeo <belangeo@gmail.com>

    * Added new object: Resample, allow multi-rate DSP chains.

2015-12-04 belangeo <belangeo@gmail.com>

    * Added Juce PyoPlugin framework in the embedded folder.

2015-10-26 belangeo <belangeo@gmail.com>

    * Fixed memory leak when using PyFloat_AS_DOUBLE(PyNumber_Float(x)) 
      to fill table data.

2015-10-25 belangeo <belangeo@gmail.com>

    * Added a closeGui() method to the Server object. This allow to 
      programatically close the Server window.

2015-10-24 belangeo <belangeo@gmail.com>

    * Added a method addMidiEvent to the Server object. This allow to 
      programatically simulate MIDI events. Added the functionnaility 
      to the embedded framework and modify the puredata pyo~ object help 
      patch to illustrate how to generate MIDI events from the host program.

2015-10-18 belangeo <belangeo@gmail.com>

    *  Fixed triangle waveform amplitude in LFO object. Fixed calculation 
       of Follower/Follower2 lowpass cutoff frequencies.

2015-10-12 belangeo <belangeo@gmail.com>

    * Final revision for version 0.7.7.
    - SHA : 217b0cb40c8b82dad8c66718910fcd6e8f983034

2015-10-11 belangeo <belangeo@gmail.com>

    * Fixed clicks at the end of the Adsr envelope.

2015-09-25 belangeo <belangeo@gmail.com>

    * Added a trigger stream to Looper to signal the beginning of a new loop.

2015-09-15 belangeo <belangeo@gmail.com>

    * Automatically add the current working directory in sys.path when the
      background server is started.

2015-09-03 belangeo <belangeo@gmail.com>

    * Added a pause() method to Linseg and Expseg objects (keep the internal phase).

2015-09-03 belangeo <belangeo@gmail.com>

    * All OSC objects now accept string or unicode types as address parameter.

2015-09-03 belangeo <belangeo@gmail.com>

    * Fixed crash (OSX) when the server GUI is closed with the red button.

2015-09-02 belangeo <belangeo@gmail.com>

    * Fixed crash on server shutdown.

2015-08-25 belangeo <belangeo@gmail.com>

    * Added new objects: MidiListener and OscListener (self-contained MIDI and OSC servers).

-------------------------------------------------------------------------------------

2015-07-27 belangeo <belangeo@gmail.com>

    * Final revision for version 0.7.6.
    - rev 1335

2015-07-24 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.6.
    - rev 1333

2015-07-24 belangeo <belangeo@gmail.com>

    * Added missing types to OscDataSend and OscDataReceive (char, blob, True, 
    False, None and MIDI packet).
    - rev 1332

2015-07-21 belangeo <belangeo@gmail.com>

    * Fixed Centroid output with silence as input.
    - rev 1330

2015-07-21 belangeo <belangeo@gmail.com>

    * Added new objet: RawMidi, a raw Midi handler.
    - rev 1329

2015-07-21 belangeo <belangeo@gmail.com>

    * Added pyoArgsAssert call in each object's methods.
    - rev 1320, 1325, 1327, 1328

2015-07-20 belangeo <belangeo@gmail.com>

    * Fixed the "segmentation fault" that occur sometimes when deleting an object.
    - rev 1326
    
2015-05-31 belangeo <belangeo@gmail.com>

    * E-Pyo: Fixed project tree.
    - rev 1315

2015-05-29 belangeo <belangeo@gmail.com>

    * E-Pyo: stderr now prints to the output panel.
    - rev 1314
 
2015-05-25 belangeo <belangeo@gmail.com>

    * E-Pyo: Added code block selection (#--> and #<-- are delimiters). 
    The background server now prints to the output panel.
    - rev 1313

2015-04-29 belangeo <belangeo@gmail.com>

    * Fixed CPU usage of PeakAmp.
    - rev 1312

-------------------------------------------------------------------------------------
2015-03-05 belangeo <belangeo@gmail.com>

    * Fixed crash when portaudio stream is stopped on OSX (created when fixed
	for Windows). Rev 1310 is the sources for 0.7.5 release.
    - rev 1310

2015-03-05 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.5.
    - rev 1308

2015-03-05 belangeo <belangeo@gmail.com>

    * Added documentation for server methods setTimeCallable and setMeterCallable.
    - rev 1304

2015-03-05 belangeo <belangeo@gmail.com>

    * Changed license to the more permissive LGPL version 3.
    - rev 1303

2015-03-03 belangeo <belangeo@gmail.com>

    * The Server can be booted with a different number of input and output channels.
    - rev 1301

2015-03-03 belangeo <belangeo@gmail.com>

    * Wraped input of Record in an InputFader object.
    - rev 1300

2015-03-03 belangeo <belangeo@gmail.com>

    * Fixed bug in Hilbert object.
    - rev 1299

2015-02-18 belangeo <belangeo@gmail.com>

    * Added mul, add and sub methods to PyoTableObject. These methods can 
    take float, list or another PyoTableObject as argument.
    - rev 1298

2015-02-13 belangeo <belangeo@gmail.com>

    * Added new objet: AtanTable, generates arctangent transfert functions.
    - rev 1296

2015-02-11 belangeo <belangeo@gmail.com>

    * Fixed a bug when changing the looping mode of the Looper object.
    - rev 1295

2015-02-09 belangeo <belangeo@gmail.com>

    * Added a reset method to the Looper objet.
    - rev 1294

2015-02-08 belangeo <belangeo@gmail.com>

    * E-Pyo: Added a refresh button to actualize the content of the folder panel.
    - rev 1292

2015-02-07 belangeo <belangeo@gmail.com>

    * E-Pyo: Added a menu item to set a master document (the one that will be executed whatever 
    which one has the focus).
    - rev 1291

2015-02-03 belangeo <belangeo@gmail.com>

    * Added getServer, getSamplingRate and getBufferSize to PyoObjectBase. These methods can be 
    accessed from any pyo objects.
    - rev 1290

2015-02-03 belangeo <belangeo@gmail.com>

    * Fixed a bug with class method referenced inside pyo object. Save them as weak reference, 
    allowing the garbage collector to properly delete the objects when reference count falls to 0.
    - rev 1289

2015-02-02 belangeo <belangeo@gmail.com>

    * Added new objet: TableWrite, records values in a table at arbitrary location.
    - rev 1288

-------------------------------------------------------------------------------------

2015-01-29 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.4
    - rev 1284

2015-01-29 belangeo <belangeo@gmail.com>

    * Added new function: floatmap, 0-1 range mapper. Fixed bug in DataTable initialization 
    and added an automatic refresh of the DataTable grapher window.
    - rev 1282

2015-01-26 belangeo <belangeo@gmail.com>

    * Added new objet: Particle, a full control granular synthesis generator.
    - rev 1281

2015-01-24 belangeo <belangeo@gmail.com>

    * Added setSync method to Granule object. Allow to toggle between synchronous 
    and asynchronous granulation. Added noteon and noteoff trigger streams to Notein 
    object.

    - rev 1280

2014-12-15 belangeo <belangeo@gmail.com>

    * Added reset method to CtlScan and CtlScan2 objects.
    - rev 1279

2014-12-03 belangeo <belangeo@gmail.com>

    * Added new objet: PeakAmp, a peak amplitude follower.
    - rev 1277

2014-11-27 belangeo <belangeo@gmail.com>

    * Added reset method to Beat and Euclide objects.
    - rev 1275

-------------------------------------------------------------------------------------

2014-10-17 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.3.
    - rev 1273

2014-11-15 belangeo <belangeo@gmail.com>

    * Added new objet: Scope, an audio waveform display.
    - rev 1270

2014-11-12 belangeo <belangeo@gmail.com>

    * E-Pyo: Fix marker's line numbering.
    - rev 1267

2014-11-08 belangeo <belangeo@gmail.com>

    * E-Pyo: Added Save As Template... menu item.
    - rev 1263

2014-11-02 belangeo <belangeo@gmail.com>

    * Fixed bug in Fader decreasing ramp.
    - rev 1262

2014-10-28 belangeo <belangeo@gmail.com>

    * Added midi output methods to the Server object. noteout, afterout, ctlout, programout, pressout and bendout.
    - rev 1261

2014-10-28 belangeo <belangeo@gmail.com>

    * Server.setMidiOutputDevice(idx) with `idx` greater than the higher portmidi devices index opens all available output devices.
    - rev 1260

2014-10-24 belangeo <belangeo@gmail.com>

    * Added new object: FToM, converts an audio stream containning frequencies in hertz to a midi note audio stream.
    - rev 1259

2014-10-23 belangeo <belangeo@gmail.com>

    * Added new function: hzToMidi, converts a frequency in hertz to a midi note value.
    - rev 1258

-------------------------------------------------------------------------------------

2014-10-17 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.2.
    - rev 1256

2014-10-16 belangeo <belangeo@gmail.com>

    * Server.setMidiInputDevice(idx) with `idx` greater than the higher portmidi input index opens all available devices.
    - rev 1254

2014-10-16 belangeo <belangeo@gmail.com>

    * OSX installer: Also install pyo in anaconda site-packages directory if exist.
    - rev 1253

2014-10-16 belangeo <belangeo@gmail.com>

    * Added new object : TrigBurst, generates a time/amplitude expandable trigger pattern.
    - rev 1252

2014-10-14 belangeo <belangeo@gmail.com>

    * Added new object : Euclide, Euclidean rhythm generator.
    - rev 1251

2014-10-13 belangeo <belangeo@gmail.com>

    * Windows installers now check for the current python installation directory before installing files.
    - rev 1244 - 1250

2014-10-10 belangeo <belangeo@gmail.com>

    * E-Pyo: Fixed inconsistencies in Find/Replace behaviours.
    - rev 1241

2014-10-10 belangeo <belangeo@gmail.com>

    * Added new object : SmoothDelay, a delay line that does not produce clicks or pitch shifting when the delay time is changing.
    - rev 1239

2014-10-08 belangeo <belangeo@gmail.com>

    * Added new object : AttackDetector, audio signal onset detection.
    - rev 1238

2014-10-07 belangeo <belangeo@gmail.com>

    * Added new object : Centroid, Computes the spectral centroid of an input signal.
    - rev 1237

-------------------------------------------------------------------------------------

2014-08-29 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.1.
    - rev 1236

2014-09-12 belangeo <belangeo@gmail.com>

    * E-Pyo: Added RadioPyo to the template choices.  
    - rev 1234

2014-09-09 belangeo <belangeo@gmail.com>

    * Fixed Compare when used with None or a string. Print a warning and set 'comp' attribute to 0. 
    - rev 1229

2014-09-05 belangeo <belangeo@gmail.com>

    * Fixed live interpreter of the server window when using arrow keys navigation.
    - rev 1228

2014-09-04 belangeo <belangeo@gmail.com>

    * E-Pyo: Check if WxPython 3.0 is installed, otherwise uses 2.8.
    - rev 1227

2014-09-02 belangeo <belangeo@gmail.com>

    * Added anti-aliasing to PyoTableObject's grapher widget. Fixed Ctrl+W on the grapher.
    - rev 1225, 1226

-------------------------------------------------------------------------------------

2014-08-29 belangeo <belangeo@gmail.com>

    * Release tag: 0.7.0.
    - rev 1224

2014-08-26 belangeo <belangeo@gmail.com>

    * pyo can now be used without any GUI toolkit (WxPython or TKinter). Widgets are simply disabled.
    - rev 1208

2014-06-22 belangeo <belangeo@gmail.com>

    * Added Server methods to auto-connect Jack ports to already opened ports.
    - rev 1201

2014-05-23 belangeo <belangeo@gmail.com>

    * E-Pyo: output log now in realtime.
    - rev 1197

2014-04-24 belangeo <belangeo@gmail.com>

    * Added new object: Tanh, hyperbolic tangent function on audio signal.
    - rev 1188

-------------------------------------------------------------------------------------

2014-04-11 belangeo <belangeo@gmail.com>

    * Release tag: 0.6.9.
    - rev 1185

2014-04-11 belangeo <belangeo@gmail.com>

    * Added lot of methods to PyoTableObject (retify, bipolarGain, invert, lowpass, fadein, fadeout, pow).
    - rev 1182

2014-04-04 belangeo <belangeo@gmail.com>

    * Added new object: PartialTable, generates waveforms made of inharmonic components.
    - rev 1177

2014-03-12 belangeo <belangeo@gmail.com>

    * Added a Scope example in examples/utilities.
    - rev 1168

2013-12-24 belangeo <belangeo@gmail.com>

    * Added new object: STRev, Stereo reverb.
    - rev 1154

2013-12-24 belangeo <belangeo@gmail.com>

    * Added dataOnly argument to SLMap. User can now control parameters, in ctrl window, that do not accept audio signal but discreet values.
    - rev 1153

2013-12-10 belangeo <belangeo@gmail.com>

    * Added new object: ComplexRes, Complex one-pole resonator filter.
    - rev 1148

2013-10-18 belangeo <belangeo@gmail.com>

    * Added new object: TrackHold, Performs a 'thru' and hold on its input signal.
    - rev 1143

-------------------------------------------------------------------------------------

2013-10-16 belangeo <belangeo@gmail.com>

    * Release tag: 0.6.8.
    - rev 1142

2013-10-16 belangeo <belangeo@gmail.com>

    * Added multi server facility and and embeded callback support for plugin development (code by Guillaume Barrette).
    - rev 1141

2013-10-06 belangeo <belangeo@gmail.com>

    * Add a channel offset to the server physical inputs and outputs.
    - rev 1136

2013-10-03 belangeo <belangeo@gmail.com>

    * Added support for reading/writing various soundfile formats. FLAC and OGG need libsndfile to be compiled with both of them enabled.
    - rev 1133

2013-07-25 belangeo <belangeo@gmail.com>

    * Added new object: PVMix, Mix the most prominent components from two phase vocoder streaming objects.
    - rev 1130

2013-07-25 belangeo <belangeo@gmail.com>

    * Added new object: TableScale, Scales values from a table and writes them into another table.
    - rev 1129

2013-07-22 belangeo <belangeo@gmail.com>

    * Added new object: Granule, another granular synthesis generator.
    - rev 1127

2013-07-16 belangeo <belangeo@gmail.com>

    * Added new object: PVBufTabLoops, phase vocoder buffer with bin independent speed playback (controlled with a PyoTableObject).
    - rev 1126

2013-07-16 belangeo <belangeo@gmail.com>

    * Added new object: PVBufLoops, phase vocoder buffer with bin independent speed playback.
    - rev 1125

2013-07-10 belangeo <belangeo@gmail.com>

    * Added new objects: PVShift, spectral frequency shifter. PVAmpMod and PVFreqMod, frequency independent modulations. 
    - rev 1124

2013-07-01 belangeo <belangeo@gmail.com>

    * Added new objects: PVDelay, spectral delays and PVBuffer, phase vocoder recorder and playback. 
    - rev 1123

2013-06-20 belangeo <belangeo@gmail.com>

    * Added setJackAuto method to the Server to disable (enabled by default) Jack ports auto-connection.
    - rev 1122

2013-06-19 belangeo <belangeo@gmail.com>

    * Added graph() method to DataTable object. Opens a multisliders window to edit the table content. 
    - rev 1120

2013-06-18 belangeo <belangeo@gmail.com>

    * Added new object: PVFilter. Spectral filtering.
    - rev 1119

2013-06-18 belangeo <belangeo@gmail.com>

    * Added new object: PVCross, PVMult, PVMorph. Spectral morphing.
    - rev 1117

2013-06-13 belangeo <belangeo@gmail.com>

    * Added new object: PVAddSynth, Phase Vocoder additive synthesis object.
    - rev 1116

2013-06-11 belangeo <belangeo@gmail.com>

    * Phase Vocoder, first draft. PVAnal, PVSynth, PVTranspose, PVVerb and PVGate.
    - rev 1114

2013-05-27 belangeo <belangeo@gmail.com>

    * E-Pyo: Added "Search in Project Files" option.
    - rev 1108

2013-05-24 belangeo <belangeo@gmail.com>

    * E-Pyo: Added Filters Menu. User-defined text processing functions.
    - rev 1107

2013-05-23 belangeo <belangeo@gmail.com>

    * Now using Sphinx to generate the API documentation.
    - rev 1105

2013-05-15 belangeo <belangeo@gmail.com>

    * Added new objects: ButLP, ButHP, ButBP, ButBR, second-order Butterworth filters.
    - rev 1104

2013-05-09 belangeo <belangeo@gmail.com>

    * Added new objects: Reson and Resonx, second-order resonant bandpass filters.
    - rev 1102

-------------------------------------------------------------------------------------

2013-05-08 belangeo <belangeo@gmail.com>

    * Release tag: 0.6.6.
    - rev 1100

2013-05-08 belangeo <belangeo@gmail.com>

    * Fixed Notein bug when receiving note-off message with positive velocity.
    - rev 1096

2013-05-07 belangeo <belangeo@gmail.com>

    * Added new object: Spectrum, Frequency spectrum analyzer.
    - rev 1095

2013-04-19 belangeo <belangeo@gmail.com>

    * Added new object: CvlVerb, convolution based reverb.
    - rev 1094

-------------------------------------------------------------------------------------

2013-04-13 belangeo <belangeo@gmail.com>

    * Release tag: 0.6.5.
    - rev 1091

2013-04-12 belangeo <belangeo@gmail.com>

    * Added new object: Average, Moving average filter.
    - rev 1090

2013-04-12 belangeo <belangeo@gmail.com>

    * Added new object: SVF, State Variable Filter with continuous filter type change.
    - rev 1089

2013-10-11 belangeo <belangeo@gmail.com>

    * Added a setStealing() method to the Notein object.
    - rev 1087

2013-10-10 belangeo <belangeo@gmail.com>

    * Added a reset() method to the PyoTableObject.
    - rev 1086

2013-03-08 belangeo <belangeo@gmail.com>

    * Added new object: Yin, pitch tracker using the Yin algorithm.
    - rev 1084

2013-03-01 belangeo <belangeo@gmail.com>

    * Graphical display of NewMatrix object now updates in real-time.
    - rev 1082

2013-02-28 belangeo <belangeo@gmail.com>

    * Graphical display of table objects now updates in real-time.
    - rev 1080

-------------------------------------------------------------------------------------

2013-02-17 belangeo <belangeo@gmail.com>

    * Release tag: 0.6.4.
    - rev 1078

2013-02-13 belangeo <belangeo@gmail.com>

    * Added pyo.USE_DOUBLE constant. 'import pyo' sets this constant to 0 and 'import pyo64' sets it to 1
    - rev 1073

2013-01-21 belangeo <belangeo@gmail.com>

    * Added __del__ method to the Server object with checks and necessary actions if the server is already started and/or booted.
    - rev 1065

2013-01-11 belangeo <belangeo@gmail.com>

    * Added new object: RCOsc. Waveform aproximation of a RC circuit.
    - rev 1063

2013-01-07 belangeo <belangeo@gmail.com>

    * Added new operators on To PyoObject. **, %, - (negative) and comparison operators.
    - rev 1062

2012-12-25 belangeo <belangeo@gmail.com>

    * Added new object: Delay1. Delays a signal by one sample.
    - rev 1058

2012-12-19 belangeo <belangeo@gmail.com>

    * Added new objects: Min and Max. Outputs minimum or maximum between two values.
    - rev 1049

2012-12-19 belangeo <belangeo@gmail.com>

    * Added a template for extending pyo with custom objects.
    - rev 1047

2012-12-18 belangeo <belangeo@gmail.com>

    * Added "sendMidiNote(pitch, velocity, channel, timestamp) method to the Server object".
    - rev 1046

2012-11-17 belangeo <belangeo@gmail.com>

    * Added new object: Atone: First-order recursive high-pass filter with variable frequency response.
    - rev 1031

2012-11-15 belangeo <belangeo@gmail.com>

    * Added new object: SuperSaw: Roland JP-8000 Supersaw emulator.
    - rev 1029

2012-11-14 belangeo <belangeo@gmail.com>

    * Added new object: TablePut: Writes values, without repetitions, from an audio stream into a DataTable.
    - rev 1027

-------------------------------------------------------------------------------------

2012-10-26 belangeo <belangeo@gmail.com>

    * rev 1025: Release tag: 0.6.3.

2012-10-13 belangeo <belangeo@gmail.com>

    * Added new function: pa_get_devices_infos: Returns info about all devices found by Portaudio.
    - rev 1024

2012-10-12 belangeo <belangeo@gmail.com>

    * Added new object: SumOsc: Discrete summation formulae to produce complex spectra.
    - rev 1023

2012-10-11 belangeo <belangeo@gmail.com>

    * Added new method to OscReceive and OscListReceive: setValue(path, value) let the user to initialize the value for a given path.
    - rev 1022

2012-10-05 belangeo <belangeo@gmail.com>

    * Added new functions: pa_get_input_max_channels and pa_get_output_max_channels.
    - rev 1020

2012-08-17 belangeo <belangeo@gmail.com>

    * Added new object: OscTrig: An oscillator reading a waveform table with sample accurate reset signal.
    - rev 1017

2012-08-17 belangeo <belangeo@gmail.com>

    * Added new object: TrigVal: Outputs a previously defined value on a trigger signal.
    - rev 1016

2012-08-01 belangeo <belangeo@gmail.com>

    * Added new object: CosLogTable: Construct a table from logarithmic-cosine segments in breakpoint fashion.
    - rev 1014

2012-08-01 belangeo <belangeo@gmail.com>

    * Added new object: LogTable: Construct a table from logarithmic segments in breakpoint fashion.
    - rev 1013

2012-07-31 belangeo <belangeo@gmail.com>

    * Added new object: Balance: Adjust rms power of an audio signal according to the rms power of another.
    - rev 1012

-------------------------------------------------------------------------------------

2012-06-30 belangeo <belangeo@gmail.com>

    * Added new object: CtlScan2. Scan for Midi controller number and Midi channel in input.
    - rev 1007

2012-06-26 belangeo <belangeo@gmail.com>

    * Added "offline_nb" mode to the Server, allowing non-blocking bounce to disk.
    - rev 1004

2012-06-13 belangeo <belangeo@gmail.com>

    * Fixed issue 34 : Better handling of type exceptions for arguments waiting for PyoObject, PyoTableObject or list.
    - rev 1000

2012-06-08 belangeo <belangeo@gmail.com>

    * Added ChebyTable.getNormTable() method to retrieve the normalization function for the current polynomial.
    - rev 996

2012-05-31 belangeo <belangeo@gmail.com>

    * E-Pyo now creates its resources folder in the user home directory.
    - rev 991

2012-05-30 belangeo <belangeo@gmail.com>

    * Fixed PyoObject.set() method bug.
    - rev 987

2012-05-26 belangeo <belangeo@gmail.com>

    * Added new function: savefileFromTable(). Used internally by PyoTableObject to save sound to disk.
    - rev 983

2012-05-25 belangeo <belangeo@gmail.com>

    * Added two methods to PyoObject class: isPlaying() and isOutputting().
    - rev 979

2012-05-25 belangeo <belangeo@gmail.com>

    * Added debugging methods utilities: Server.getStreams(), Server.getNumberOfStreams() and Stream.getStreamObject().
    - rev 977

2012-05-24 belangeo <belangeo@gmail.com>

    * Fixed memory leak on object's deletion (refcount was always one more than expected).
    - rev 974

2012-05-10 belangeo <belangeo@gmail.com>

    * Removed printing to the console from pa_get_* and pm_get_* functions.
    - rev 973

2012-05-10 belangeo <belangeo@gmail.com>

    * Added new object: Vocoder. Vocoder effect.
    - rev 972

2012-05-09 belangeo <belangeo@gmail.com>

    * Ensures that every example in the examples folder that don't need audio input have the duplex mode set to 0.
    - rev 971

2012-05-09 belangeo <belangeo@gmail.com>

    * Added new object: MatrixRecLoop. Records samples in loop into a previously created NewMatrix.
    - rev 970

2012-05-08 belangeo <belangeo@gmail.com>

    * Fixed issue 30. Lin/Exp/Cos/CurveTable compare size with last position in the list and increase size if needed.
    - rev 969

2012-05-08 belangeo <belangeo@gmail.com>

    * Added compiler flag --no-messages to suppress startup messages.
    - rev 968

-------------------------------------------------------------------------------------

2012-05-02 belangeo <belangeo@gmail.com>

    * rev 966 - Upgraded version number to 0.6.2, release tag: 0.6.1.

2012-04-28 belangeo <belangeo@gmail.com>

    * Added new function : convertStringToSysEncoding. For users who use non-ascii characters in their path.
    - rev 945

2012-04-13 belangeo <belangeo@gmail.com>

    * Added new object : NextTrig. A trigger opens a gate only for the next one.
    - rev 925

2012-04-13 belangeo <belangeo@gmail.com>

    * Added PyoObject.range(min, max) method. Adjust mul and add attributes.
    - rev 923

2012-04-13 belangeo <belangeo@gmail.com>

    * Added new object : Urn. Periodic pseudo-random integer generator without duplicates.
    - rev 922

2012-04-09 belangeo <belangeo@gmail.com>

    * Added new object : Count. Counts integers at audio rate.
    - rev 919

2012-04-06 belangeo <belangeo@gmail.com>

    * Added new object : OscListReceive. Handles list of floats from OSC as audio streams.
    - rev 914

2012-04-03 belangeo <belangeo@gmail.com>

    * Added functionalities to OSC objects (add, remove, setInterpolation, etc.).
    - rev 913

-------------------------------------------------------------------------------------

2012-01-03 belangeo <belangeo@gmail.com>

    * rev 807 - Updated version number, release tag: 0.6.0.

2011-12-22 belangeo <belangeo@gmail.com>

    * Added new object: MToT. Midi to transposition factor conversion.
    - rev 805

2011-12-20 belangeo <belangeo@gmail.com>

    * Added new objects: XnoiseDur,  Recursive time varying X-class pseudo-random generator. SincTable, sinc window function.
    - rev 803

2011-12-19 belangeo <belangeo@gmail.com>

    * Added new object: VoiceManager. Polyphony voice manager.
    - rev 802

2011-12-14 belangeo <belangeo@gmail.com>

    * Added downsamp() function. Sampling rate conversion of a soundfile.
    - rev 798

2011-12-13 belangeo <belangeo@gmail.com>

    * Added upsamp() function. Sampling rate conversion of a soundfile.
    - rev 797

2011-12-13 belangeo <belangeo@gmail.com>

    * Added copy() method to the PyoTableObject.
    - rev 796

2011-12-12 belangeo <belangeo@gmail.com>

    * Added reverse() method to the PyoTableObject.
    - rev 795

2011-12-11 belangeo <belangeo@gmail.com>

    * Added removeDC() method to the PyoTableObject.
    - rev 794

2011-12-07 belangeo <belangeo@gmail.com>

    * Added new object: Biquada. Biquadratric filter controlled with filter's coefficients.
    - rev 793

2011-12-05 belangeo <belangeo@gmail.com>

    * Added new function: distanceToSegment. Find the distance from a point to a line or line segment.
    - rev 790

2011-11-29 belangeo <belangeo@gmail.com>

    * Added new object: Iter. Triggers iterate over a list of user-defined values.
    - rev 784

2011-11-26 belangeo <belangeo@gmail.com>

    * Added new object: Vectral. Performs magnitude smoothing between successive frames.
    - rev 782

2011-11-23 belangeo <belangeo@gmail.com>

    * Added server's attribute : globalseed. An int used as the seed by random objects. Can be changed multiple times inside a script.
    - rev 778

2011-11-22 belangeo <belangeo@gmail.com>

    * Added new object: RandDur. Recursive time varying pseudo-random generator.
    - rev 776

2011-11-22 belangeo <belangeo@gmail.com>

    * Added new object: Timer. Reports elpased time between two triggers.
    - rev 772

2011-11-15 belangeo <belangeo@gmail.com>

    * Added mouse callback to SndTable.view method to allow simple scrubbing.
    - rev 763

2011-11-09 belangeo <belangeo@gmail.com>

    * midiToHz and midiToTranspo now accept list or tuple in input.
    - rev 759

2011-11-04 belangeo <belangeo@gmail.com>

    * Snap takes choice on more than one octave.
    - rev 754

2011-10-27 belangeo <belangeo@gmail.com>

    * Added new object: MToF. Midi to frequency conversion.
    - rev 748

2011-10-26 belangeo <belangeo@gmail.com>

    * Added new objects: CentsToTranspo and TranspoToCents. Cents/transposition factor conversions.
    - rev 747

2011-10-26 belangeo <belangeo@gmail.com>

    * Added new object: Scale. Maps an input range of audio values to an output range.
    - rev 746

2011-10-25 belangeo <belangeo@gmail.com>

    * Added new objects: DBToA and AToDB. Amplitude/decibel conversions.
    - rev 745

2011-10-22 belangeo <belangeo@gmail.com>

    * Added "append" and "insert" methods to SndTable object.
    - rev 740

2011-10-13 belangeo <belangeo@gmail.com>

    * Added new objects : Touchin : Get the current value of the after-touch controller. Programin : Get the current value of a program change controller.
    - rev 730

2011-10-13 belangeo <belangeo@gmail.com>

    * Added new object : Bendin : Get the current value of the pitch bend controller.
    - rev 729

2011-10-12 belangeo <belangeo@gmail.com>

    * Added midi channel attributes to Midictl and Notein. Added setCentralKey(x) method to Notein.
    - rev 726

2011-10-05 belangeo <belangeo@gmail.com>

    * Added new object : Ceil : Returns the smallest integral value greater than or equal to the input signal.
    - rev 720

2011-10-02 belangeo <belangeo@gmail.com>

    * Added new object : MidiDelAdsr : Midi triggered ADSR envelope with pre-delay.
    - rev 719

2011-09-25 belangeo <belangeo@gmail.com>

    * Updated version number to 0.5.1.
    - rev 713

2011-08-13 belangeo <belangeo@gmail.com>

    * Added new object : CtlScan : Scan for Midi controller number in input.
    - rev 707

-------------------------------------------------------------------------------------

2011-07-31 belangeo <belangeo@gmail.com>

    * rev 702 - pyo 0.5.0 release.

2011-07-31 belangeo <belangeo@gmail.com>

    * Added new objects : NoteinRec and NoteinRead. Records and reads Notein automations.
    - rev 701

2011-08-30 belangeo <belangeo@gmail.com>

    * Added new object : WinTable. Generates different kind of windowing functions. 
    - rev 700

2011-07-22 belangeo <belangeo@gmail.com>

    * Added new function : reducePoints(), apply a DouglasPeucker curve reduction algorithm. 
      Added loadRecFile() method to table objects.
    - rev 688

2011-07-20 belangeo <belangeo@gmail.com>

    * Added new objects : ControlRec and ControlRead. Records automations at user-defined sampling rate.
    - rev 687

2011-07-18 belangeo <belangeo@gmail.com>

    * Added C impementation of the Looper object.
    - rev 682

2011-07-07 belangeo <belangeo@gmail.com>

    * Added new arithmetic object: Round.
    - rev 675

2011-07-06 belangeo <belangeo@gmail.com>

    * Added new arithmetic object: Floor.
    - rev 674

2011-07-03 belangeo <belangeo@gmail.com>

    * Added new objects: OscDataSend and OscDataReceive.
    - rev 668

2011-06-15 belangeo <belangeo@gmail.com>

    * Added 'feedback' attribute to NewTable object.
    - rev 659

2011-06-14 belangeo <belangeo@gmail.com>

    * New object : TrigTableRec.
    - rev 658

2011-06-02 belangeo <belangeo@gmail.com>

    * Added cartesian to polar and polar to cartesian conversions.
    - rev 655

2011-06-01 belangeo <belangeo@gmail.com>

    * Protected (self->steps == 0) in line generation to avoid division by zero.
    - rev 654

2011-05-31 belangeo <belangeo@gmail.com>

    * Added Fast Fourier Transform (FFT, IFFT).
    - rev 652

-------------------------------------------------------------------------------------

2011-05-18 belangeo <belangeo@gmail.com>

    * Added getVersion() function and upgrade version number to '0.4.1'.
    - rev 645

2011-05-18 belangeo <belangeo@gmail.com>

    * Improved soundfile player family (SfPlayer, SfMarkerShuffler and SfMarkerLooper).
    - rev 644

2011-05-13 belangeo <belangeo@gmail.com>

    * New object : FourBand (linear phase spectrum splitter).
    - rev 640

2011-05-11 belangeo <belangeo@gmail.com>

    * New object : ParaTable (parabola window function).
    - rev 637

2011-05-11 belangeo <belangeo@gmail.com>

    * Added 'outputAmp' argument to Compress and Gate. Useful to link several channels.
    - rev 636

2011-05-10 belangeo <belangeo@gmail.com>

    * New object: Gate (noise gate).
    - rev 635

2011-05-10 belangeo <belangeo@gmail.com>

    * New object: Follower2 (different attack and release times).
    - rev 634

2011-05-10 belangeo <belangeo@gmail.com>

    * Completely redesigned Follower.
    - rev 633

2011-05-10 belangeo <belangeo@gmail.com>

    * Completely redesigned Compress.
    - rev 632

2011-05-05 belangeo <belangeo@gmail.com>

    * SigTo can be used with PyoObject as input value.
    - rev 631

2011-05-03 belangeo <belangeo@gmail.com>

    * Port filter optimization.
    - rev 630


2011-05-03 belangeo <belangeo@gmail.com>

    * Fixed glitches in objects using recursive delay lines.
    - rev 629

2011-05-02  belangeo <belangeo@gmail.com>

    * Fixed bug in Expseg and TrigExpseg "exp" argument initilization.
    - rev 624

-------------------------------------------------------------------------------------

2011-02-29 belangeo <belangeo@gmail.com>

    * rev 622 - pyo 0.4.0 release.

2011-04-26 belangeo <belangeo@gmail.com>

    * Added new object : OscBank. Mixes any number of oscillators.
    - rev 606

2011-04-22 belangeo <belangeo@gmail.com>

    * Added new object : FreqShift, frequency shifter using single sideband amplitude modulation.
    - rev 605

2011-04-15 belangeo <belangeo@gmail.com>

    * Added new object : Denorm.
    - rev 601

2011-04-15 belangeo <belangeo@gmail.com>

    * Added portaudio non-interleaved callback for ASIO support.
    - rev 577

2011-04-15 belangeo <belangeo@gmail.com>

    * Fixed crash when duplex=0 on Windows
    - rev 574

2011-04-10 belangeo <belangeo@gmail.com>

    * New object : MidiAdsr, a Midi triggered ADSR envelope generator.
    - rev 572

2011-04-01 belangeo <belangeo@gmail.com>

    * New objects : LFO, Band-limited Low Frequency Oscillator with different wave shapes.
    - rev 571

2011-03-27 belangeo <belangeo@gmail.com>

    * New chaotic attractor objects : Lorenz and Rossler
    - rev 567

2011-03-14 belangeo <belangeo@gmail.com>

    * Convolution-based filter family : IRWinSinc, IRPulse, IRAverage, IRFM
    - rev 565

2011-03-02 belangeo <belangeo@gmail.com>

    * Added new object : BrownNoise
    - rev 564

2011-03-02 belangeo <belangeo@gmail.com>

    * Added new object : Wrap (Wraps-around the signal that exceeds the `min` and `max` thresholds.)
    - rev 562

2011-03-01 belangeo <belangeo@gmail.com>

    * Added new object : Mirror (Reflects the signal that exceeds the `min` and `max` thresholds.)
    - rev 561

2011-03-01 belangeo <belangeo@gmail.com>

    * Added new object : Between (Output a trig if input is between `min` and `max`)
    - rev 558

2011-02-27 belangeo <belangeo@gmail.com>

    * Added new object : CrossFM
    - rev 552

2011-02-26 belangeo <belangeo@gmail.com>

    * Added new object : PinkNoise
    - rev 551

2011-02-26 belangeo <belangeo@gmail.com>

    * Added new object : Blit (Band Limited Impulse Train)
    - rev 550

2011-02-23 belangeo <belangeo@gmail.com>

    * Added new object : AllpassWG
    - rev 548

2011-02-21 belangeo <belangeo@gmail.com>

    * All trig signals can be treated as number, allowing arithmetic operations.
    - rev 547

-------------------------------------------------------------------------------------

2010-02-20 belangeo <belangeo@gmail.com>

    * rev 544 - pyo 0.03 release.

2010-12-30 belangeo <belangeo@gmail.com>

    * Added new object : Mixer
    - rev 537

2010-12-13 belangeo <belangeo@gmail.com>

    * Added graph() method to some PyoTableObjects, allowing the
      control of the envelope's shape with a grapher window.
    - rev 532


-------------------------------------------------------------------------------------

2010-11-02 belangeo <belangeo@gmail.com>

    * rev 515 - pyo 0.02 release.


2010-10-24 belangeo <belangeo@gmail.com>

    * Fixed timming issue.
    - rev 507


2010-10-09 belangeo <belangeo@gmail.com>

    * Added `starttime` attribute to the server, allowing faster rendering
      of a first part of a piece.
    - rev 473

2010-10-08 belangeo <belangeo@gmail.com>

    * Added a clock of the current time in the server window and allow
      server's customization with parameters in the .gui() method.
    - rev 468

2010-10-07 belangeo <belangeo@gmail.com>

    * Added new object : MatrixMorph
    - rev 463

2010-10-04 mantaraya36 <mantaraya36@gmail.com>
           belangeo <belangeo@gmail.com>

    * Added offline rendering.
    - rev 452

2010-09-30 belangeo <belangeo@gmail.com>

    * Added support for wxPython toolkit. If wx is installed, pyo will
      use it instead of Tk.
    - rev 442

2010-09-23 belangeo <belangeo@gmail.com>

    * Added new objet : Percent
    - rev 434

2010-09-21 belangeo <belangeo@gmail.com>

    * Added support for Coreaudio backend.
      Build with --use-coreaudio option.
    - rev 431

2010-09-17 mantaraya36 <mantaraya36@gmail.com>

    * Added support for Jack audio backend.
      Build with --use-jack option.
    - rev 423

2010-09-16 belangeo <belangeo@gmail.com>

    * Added --use-double option to compile pyo in double version.
    It creates a new library, called _pyo64.so, in the same directory
    as _pyo.so. To use it, simply import pyo64 (from pyo64 import *).
    - rev 417.

2010-09-13 belangeo <belangeo@gmail.com>

    * Added "dur" and "delay" arguments to play and out methods of PyoObject.
    - rev 413.

-------------------------------------------------------------------------------------

2010-09-06 belangeo <belangeo@gmail.com>

    * rev 390 - pyo 0.01 release.


